// project created on 13/05/2003 at 15:01
using System;
using System.Windows.Forms;
using System.Threading;

namespace MyFormProject 
{
	class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdError4;
		private System.Windows.Forms.Button cmdError3;
		private System.Windows.Forms.Button cmdError2;
		private System.Windows.Forms.Button cmdError1;
		private System.Windows.Forms.TextBox edtError3;
		private System.Windows.Forms.TextBox edtError4;
		private System.Windows.Forms.Label lblError4;
		private System.Windows.Forms.Label lblError3;
		public MainForm()
		{
			InitializeComponent();
		}
	
		void cmdError1Click(object sender, System.EventArgs e)
		{
			int x, y, z;
			x = 3;
			y = 0;
			z = x / y;
		}
		
		void cmdError2Click(object sender, System.EventArgs e)
		{
			int x, y, z;
			try
			{
				x = 3;
				y = 0;
				z = x / y;
			}
			catch(Exception a)
			{
				MessageBox.Show("Exception thrown - " + a.Message, "Exception test program",
				                MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
		
		void cmdError3Click(object sender, System.EventArgs e)
		{
			int x, y, z;
			try
			{
				x = 3000;
				y = Convert.ToInt32(edtError3.Text);
				z = x / y;
				MessageBox.Show("Result is " + Convert.ToString(z), "Exception test program",
				                MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
			catch(DivideByZeroException a)
			{
				MessageBox.Show("Divide by Zero exception thrown - " + a.Message, "Exception test program",
				                MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			catch(ArithmeticException a)
			{
				MessageBox.Show("Arithmetic exception thrown - " + a.Message, "Exception test program",
				                MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			catch(Exception a)
			{
				MessageBox.Show("Exception of type " + a.GetType() + " thrown - " + a.Message, "Exception test program",
				                MessageBoxButtons.OK, MessageBoxIcon.Error);
				throw new Exception("There was an Exception", a);
			}
		}
		
		void cmdError4Click(object sender, System.EventArgs e)
		{
			int x, y, z;
			System.Drawing.Color oldColour;
			oldColour = this.BackColor;
			this.BackColor = System.Drawing.Color.Red;
			this.Refresh();
			try
			{
				try
				{
					x = 3000;
					y = Convert.ToInt32(edtError4.Text);
					z = x / y;
					MessageBox.Show("Result is " + Convert.ToString(z), "Exception test program",
					                MessageBoxButtons.OK, MessageBoxIcon.Information);
				}
				catch(DivideByZeroException a)
				{
					MessageBox.Show("Divide by Zero exception thrown - " + a.Message, "Exception test program",
					                MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				catch(ArithmeticException a)
				{
					MessageBox.Show("Arithmetic exception thrown - " + a.Message, "Exception test program",
					                MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				catch(Exception a)
				{
					MessageBox.Show("Exception of type " + a.GetType() + " thrown - " + a.Message, "Exception test program",
					                MessageBoxButtons.OK, MessageBoxIcon.Error);
					throw new Exception("There was an Exception", a);
				}
			}
			finally
			{
				this.BackColor = oldColour;
			}
		}
		
		// THIS METHOD IS MAINTAINED BY THE FORM DESIGNER
		// DO NOT EDIT IT MANUALLY! YOUR CHANGES ARE LIKELY TO BE LOST
		void InitializeComponent() {
			this.lblError3 = new System.Windows.Forms.Label();
			this.lblError4 = new System.Windows.Forms.Label();
			this.edtError4 = new System.Windows.Forms.TextBox();
			this.edtError3 = new System.Windows.Forms.TextBox();
			this.cmdError1 = new System.Windows.Forms.Button();
			this.cmdError2 = new System.Windows.Forms.Button();
			this.cmdError3 = new System.Windows.Forms.Button();
			this.cmdError4 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblError3
			// 
			this.lblError3.AutoSize = true;
			this.lblError3.Location = new System.Drawing.Point(96, 88);
			this.lblError3.Name = "lblError3";
			this.lblError3.Size = new System.Drawing.Size(78, 22);
			this.lblError3.TabIndex = 4;
			this.lblError3.Text = "Divide by:";
			// 
			// lblError4
			// 
			this.lblError4.AutoSize = true;
			this.lblError4.Location = new System.Drawing.Point(96, 128);
			this.lblError4.Name = "lblError4";
			this.lblError4.Size = new System.Drawing.Size(78, 22);
			this.lblError4.TabIndex = 7;
			this.lblError4.Text = "Divide by:";
			// 
			// edtError4
			// 
			this.edtError4.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F);
			this.edtError4.Location = new System.Drawing.Point(176, 128);
			this.edtError4.Name = "edtError4";
			this.edtError4.TabIndex = 6;
			this.edtError4.Text = "";
			// 
			// edtError3
			// 
			this.edtError3.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.edtError3.Location = new System.Drawing.Point(176, 88);
			this.edtError3.Name = "edtError3";
			this.edtError3.TabIndex = 3;
			this.edtError3.Text = "";
			// 
			// cmdError1
			// 
			this.cmdError1.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdError1.Location = new System.Drawing.Point(8, 8);
			this.cmdError1.Name = "cmdError1";
			this.cmdError1.TabIndex = 0;
			this.cmdError1.Text = "Error!";
			this.cmdError1.Click += new System.EventHandler(this.cmdError1Click);
			// 
			// cmdError2
			// 
			this.cmdError2.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdError2.Location = new System.Drawing.Point(8, 48);
			this.cmdError2.Name = "cmdError2";
			this.cmdError2.TabIndex = 1;
			this.cmdError2.Text = "Error2!";
			this.cmdError2.Click += new System.EventHandler(this.cmdError2Click);
			// 
			// cmdError3
			// 
			this.cmdError3.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cmdError3.Location = new System.Drawing.Point(8, 88);
			this.cmdError3.Name = "cmdError3";
			this.cmdError3.TabIndex = 2;
			this.cmdError3.Text = "Error3!";
			this.cmdError3.Click += new System.EventHandler(this.cmdError3Click);
			// 
			// cmdError4
			// 
			this.cmdError4.Location = new System.Drawing.Point(8, 128);
			this.cmdError4.Name = "cmdError4";
			this.cmdError4.TabIndex = 5;
			this.cmdError4.Text = "Error4!";
			this.cmdError4.Click += new System.EventHandler(this.cmdError4Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
			this.ClientSize = new System.Drawing.Size(416, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
						this.lblError4,
						this.edtError4,
						this.cmdError4,
						this.lblError3,
						this.edtError3,
						this.cmdError3,
						this.cmdError2,
						this.cmdError1});
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Text = "Exception Testing";
			this.ResumeLayout(false);
		}
			
		public static void DefaultErrorHandler(object sender, ThreadExceptionEventArgs args) 
		{
			Exception e = args.Exception;
			MessageBox.Show("MyHandler caught : " + e.Message,
							"Exception test program",
							MessageBoxButtons.OK,
							MessageBoxIcon.Error);
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.ThreadException += 
				new System.Threading.ThreadExceptionEventHandler(DefaultErrorHandler);
			Application.Run(new MainForm());
		}
	}			
}
